unit BusObjs;

interface
uses FileObj,Classes,Contnrs,sysutils;
Type
 TADUGBusObj=Class(TPersistFileObject)
   Private
    FListOfObject:TStringList;
    FStringIndexBase:String;
   Public
    FInt1:Integer;
    FReal1:Real;
    Function     CountOfSubs:Integer;
    Procedure    SetIndexBase;
    Procedure    RefreshStringLists;
    Constructor  Create(IntOwnerList,IntOwner:Pointer);Override;
    Destructor   Destroy;Override;
    procedure    Load(var s:Tstream);  Override;
    procedure    Store(var s:Tstream); Override;
    Procedure    Edit;
    Property     ObjectList:TStringList Read FListOfObject;
    Property     OwnerList:Pointer Read FOwnerList;
    Property     StringIndexBase:String Read FStringIndexBase;
   end;


implementation

uses rcStdLib, EditFrm;



{ ADUGBusObj }

function TADUGBusObj.CountOfSubs: Integer;
Var
  i,CurCount:Integer;
  NextObj:TADUGBusObj;
begin
  CurCount:=0;
  If FListOfObject<>nil then
    For i:=0 to FListOfObject.Count-1 do
      Begin
        NextObj:=FListOfObject.objects[i]as TADUGBusObj;
        CurCount:=CurCount+NextObj.CountOfSubs+1;//+1 for this object
      end;
  Result:=CurCount;
end;


constructor TADUGBusObj.Create(IntOwnerList, IntOwner: Pointer);
begin
  inherited;
  FListOfObject:=TStringList.Create;
  SetIndexBase;
end;

destructor TADUGBusObj.Destroy;
begin
  FreeSList(FListOfObject);
  inherited;
end;

procedure TADUGBusObj.Edit;
Var
  Form:TEditForm;
begin
  Form:=TEditForm.Create(nil);
  Form.SetData(Self);
  Form.ShowModal;
end;

procedure TADUGBusObj.Load(var s: Tstream);
begin
  inherited;
  s.Read(  FInt1,SizeOf(FInt1));
  s.Read(  FReal1,SizeOf(FReal1));
  ReadStrmList(s,FListOfObject);
 end;

procedure TADUGBusObj.RefreshStringLists;
Var
  i:Integer;
  CurObj:TADUGBusObj;
begin
  For i:=0 to FListOfObject.Count-1 do
    Begin
      CurObj:=FListOfObject.Objects[i] as TADUGBusObj;
      FListOfObject[i]:=CurObj.FStringIndexBase+' #'+IntToStr(CurObj.CountOfSubs);
    end;
end;

procedure TADUGBusObj.SetIndexBase;
begin
    If FOwner=nil then
      FStringIndexBase:='Object Ref -'+IntToStr(FListOfObject.Count)
    Else
     If FOwner is TADUGBusObj then
         FStringIndexBase:=TADUGBusObj(FOwner).FStringIndexBase+
                               '-'+IntToStr(TADUGBusObj(FOwner).FListOfObject.Count)
      else
       If (FOwnerList<>nil)and(TObject(FOwnerList) is TStringList) then
           FStringIndexBase:='Object Ref -'+IntToStr(TStringList(FOwnerList).Count)
        Else
          FStringIndexBase:='Weird ';
end;

procedure TADUGBusObj.Store(var s: Tstream);
begin
  inherited;
  s.Write(  FInt1,SizeOf(FInt1));
  s.Write(  FReal1,SizeOf(FReal1));
  WriteStrmList(s,FListOfObject);

end;
Initialization
   RegPersistentClasses([TADUGBusObj]);


end.
