unit BusObjsMulti;

interface
uses ISDbFileObj,PMultiUserFileStm,Classes,Contnrs,Controls,sysutils;
Type
 TADUGMultiBusObj=Class(TMultiUserDbBaseObj)
   Private
    FListOfObject:TStringList;
    FOwnerList: Pointer;
    Function     CountOfSubs:Integer;
   Public
    FMInt1:Integer;
    FMReal1:Real;
    Constructor  Create(IntOwnerList,IntOwner:Pointer);Override;
    Destructor   Destroy;Override;
    procedure    Load(var s:Tstream);  Override;
    procedure    Store(var s:Tstream); Override;
    Procedure    Edit;
    Procedure    RefreshStringLists;
    Property     ObjectList:TStringList Read FListOfObject;
    Property     OwnerList:Pointer Read FOwnerList;
   end;

 TADUGIndexedDb=Class(TMultiUserDBObjectFile)
    Private
     Function TextIndex(APtr:Pointer):String;
    Public
     Constructor Create(const FName:String;OpenMode:Word); Override;
    end;

implementation

uses rcStdLib, EditMultiFrm, FileObj, BusObjs;



{ ADUGMultiBusObj }

function TADUGMultiBusObj.CountOfSubs: Integer;
Var
  i,CurCount:Integer;
  NextObj:TADUGBusObj;
begin
  CurCount:=0;
  If FListOfObject<>nil then
    For i:=0 to FListOfObject.Count-1 do
      Begin
        NextObj:=FListOfObject.objects[1]as TADUGBusObj;
        CurCount:=CurCount+NextObj.CountOfSubs+1;//+1 for this object
      end;
  Result:=CurCount;
end;

constructor TADUGMultiBusObj.Create(IntOwnerList, IntOwner: Pointer);
begin
  inherited;
  FListOfObject:=TStringList.Create;
end;

destructor TADUGMultiBusObj.Destroy;
begin
  FreeSList(FListOfObject);
  inherited;
end;

procedure TADUGMultiBusObj.Edit;
Var
  Form:TEditMultiForm;
begin
  LockObj:=True;
  If LockObj then
     Try
        Form:=TEditMultiForm.Create(nil);
        Form.SetData(Self);
        If mrOk=Form.ShowModal then
           If Not SaveToDb then
               Raise Exception.Create('Error on Save');
     Finally
       LockObj:=False;
     End
   Else Raise Exception.Create('This Object is Currently Locked');
end;

procedure TADUGMultiBusObj.Load(var s: Tstream);
begin
  inherited;
  s.Read(  FMInt1,SizeOf(FMInt1));
  s.Read(  FMReal1,SizeOf(FMReal1));
  ReadStrmList(s,FListOfObject);
 end;

procedure TADUGMultiBusObj.RefreshStringLists;
Var
  i:Integer;
  CurObj:TADUGBusObj;
begin
  For i:=0 to FListOfObject.Count-1 do
    Begin
      CurObj:=FListOfObject.Objects[i] as TADUGBusObj;
      FListOfObject[i]:=CurObj.StringIndexBase+' #'+IntToStr(CurObj.CountOfSubs);
    end;
end;


procedure TADUGMultiBusObj.Store(var s: Tstream);
begin
  inherited;
  s.Write(  FMInt1,SizeOf(FMInt1));
  s.Write(  FMReal1,SizeOf(FMReal1));
  WriteStrmList(s,FListOfObject);

end;
{ TADUGIndexedDb }

constructor TADUGIndexedDb.Create(const FName: String; OpenMode: Word);
begin
  inherited;
  AddIndex(TextIndex,idx0);
end;

function TADUGIndexedDb.TextIndex(APtr: Pointer): String;
begin
 With TADUGMultiBusObj(APtr)do
  Result:= IntToStr(FMInt1)+'  '+FloatToStr(FMReal1)+'>>'+IntToStr(Index)+
     'Total Objs='+IntToStr(CountOfSubs);
end;

Initialization
   RegPersistentClasses([TADUGMultiBusObj]);


end.
