unit EditFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TEditForm = class(TForm)
    ListBox1: TListBox;
    BtnAddObject: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    BTNOk: TButton;
    procedure ListBox1DblClick(Sender: TObject);
    procedure BtnAddObjectClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Edit1Exit(Sender: TObject);
  private
    { Private declarations }
    FCurBusObj:Pointer;
  public
    { Public declarations }
    Procedure SetData(Data:Pointer);
  end;

implementation

uses BusObjs;

{$R *.dfm}

procedure TEditForm.ListBox1DblClick(Sender: TObject);
Var
  LclIndex:Integer;
  LclObj:TADUGBusObj;
begin
  Try
  Visible:=false;
  LclIndex:= ListBox1.ItemIndex;
  If LclIndex<0 then exit;
  LclObj:=TADUGBusObj(ListBox1.Items.Objects[LclIndex]);
  if LclObj<>nil then
             LclObj.Edit;
  If FCurBusObj<>nil then
     begin
       TADUGBusObj(FCurBusObj).RefreshStringLists;
       SetData(FCurBusObj); // Redraw the Edit
     end;
  Finally
    Visible:=True;
  end;
end;

procedure TEditForm.BtnAddObjectClick(Sender: TObject);
Var
  LclObj,CurObj:TADUGBusObj;

begin
  CurObj:=FCurBusObj;
  if CurObj=nil then exit;
  LclObj:=TADUGBusObj.Create(CurObj.ObjectList,FCurBusObj);
  CurObj.ObjectList.AddObject('New',LclObj);
  SetData(FCurBusObj);
end;

procedure TEditForm.SetData(Data: Pointer);
Var
  LclObj:TADUGBusObj;
begin
  If Data=nil then exit;
  LclObj:= TObject(Data) as TADUGBusObj;
  FCurBusObj:=LclObj;
  Edit1.Text:=IntToStr(LclObj.FInt1);
  Edit2.Text:=FloatToStr(LclObj.FReal1);
  ListBox1.Items.Clear;
  ListBox1.Items.AddStrings(LclObj.ObjectList);
end;

procedure TEditForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
Var
  LclObj:TADUGBusObj;
begin
  If FCurBusObj=nil then exit;
  If ModalResult<>mrOk then Exit;  //Quit;
  LclObj:=FCurBusObj;
  Try
    LclObj.FInt1:=StrToInt(Edit1.Text);
    LclObj.RefreshStringLists;
  Except
    CanClose:=False;
    Edit1.Color:=clYellow;
  End;
  Try
    LclObj.FReal1:=StrToFloat(Edit2.Text);
  Except
    CanClose:=False;
    Edit2.Color:=clYellow;
  End;
  If Not CanClose then
      SetData(FCurBusObj);
end;

procedure TEditForm.Edit1Exit(Sender: TObject);
begin
  TEdit(Sender).Color:=clWhite;
end;

end.
