unit EditMultiFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TEditMultiForm = class(TForm)
    ListBox1: TListBox;
    BtnAddObject: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    BTNOk: TButton;
    procedure ListBox1DblClick(Sender: TObject);
    procedure BtnAddObjectClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Edit1Exit(Sender: TObject);
  private
    { Private declarations }
    FCurBusObj:Pointer;
  public
    { Public declarations }
    Procedure SetData(Data:Pointer);
  end;

var
  EditMultiForm: TEditMultiForm;

implementation

uses BusObjsMulti, BusObjs;

{$R *.dfm}

procedure TEditMultiForm.ListBox1DblClick(Sender: TObject);
Var
  LclIndex:Integer;
  LclObj:TADUGBusObj;
begin
  Try
  Visible:=false;
  LclIndex:= ListBox1.ItemIndex;
  If LclIndex<0 then exit;
  LclObj:=TADUGBusObj(ListBox1.Items.Objects[LclIndex]);
  if LclObj<>nil then
             LclObj.Edit;
  If FCurBusObj<>nil then
     begin
       TADUGMultiBusObj(FCurBusObj).RefreshStringLists;
       SetData(FCurBusObj); // Redraw the Edit
     end;
  Finally
    Visible:=True;
  end;
end;

procedure TEditMultiForm.BtnAddObjectClick(Sender: TObject);
Var
  LclObj:TADUGBusObj;
  CurObj:TADUGMultiBusObj;
  IndexStrg:String;
begin
  CurObj:=FCurBusObj;
  if CurObj=nil then exit;
  LclObj:=TADUGBusObj.Create(CurObj.ObjectList,FCurBusObj);
  If CurObj.OwnerList=nil then
      IndexStrg:='Object Ref -'+IntToStr(CurObj.ObjectList.Count)
    Else
      With TStringList(CurObj.OwnerList) do
        Begin
          IndexStrg:=Strings[IndexofObject(CurObj)]+
                   '-'+IntToStr(CurObj.ObjectList.Count);
        end;
  CurObj.ObjectList.AddObject(IndexStrg,LclObj);
  SetData(FCurBusObj);
end;

procedure TEditMultiForm.SetData(Data: Pointer);
Var
  LclObj:TADUGMultiBusObj;
begin
  If Data=nil then exit;
  LclObj:= TObject(Data) as TADUGMultiBusObj;
  FCurBusObj:=LclObj;
  Edit1.Text:=IntToStr(LclObj.FMInt1);
  Edit2.Text:=FloatToStr(LclObj.FMReal1);
  ListBox1.Items.Clear;
  ListBox1.Items.AddStrings(LclObj.ObjectList);
end;

procedure TEditMultiForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
Var
  LclObj:TADUGMultiBusObj;
begin
  If FCurBusObj=nil then exit;
  If ModalResult<>mrOk then Exit;  //Quit;
  LclObj:=FCurBusObj;
  Try
    LclObj.FMInt1:=StrToInt(Edit1.Text);
  Except
    CanClose:=False;
    Edit1.Color:=clYellow;
  End;
  Try
    LclObj.FMReal1:=StrToFloat(Edit2.Text);
  Except
    CanClose:=False;
    Edit2.Color:=clYellow;
  End;
  If Not CanClose then
      SetData(FCurBusObj);
end;

procedure TEditMultiForm.Edit1Exit(Sender: TObject);
begin
  TEdit(Sender).Color:=clWhite;
end;

end.
