unit MultiFileDbFm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, PMultiUserFileStm, ExtCtrls;

type
  TMultiUsrDbForm = class(TForm)
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    BtnNewDbCreate: TButton;
    BtnGetDb: TButton;
    BtnNewBusObj: TButton;
    ListBox1: TListBox;
    TimerRefreshForm: TTimer;
    procedure BtnGetDbClick(Sender: TObject);
    procedure BtnNewBusObjClick(Sender: TObject);
    procedure BtnNewDbCreateClick(Sender: TObject);
    procedure TimerRefreshFormTimer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ListBox1DblClick(Sender: TObject);
  private
    { Private declarations }
    FDbFile:TMultiUserDBObjectFile;
    Procedure RefreshForm;
    //FBusObject:TObject;
  public
    { Public declarations }
  end;

Var
     MultiUsrDbForm:TMultiUsrDbForm;
implementation

uses  BusObjsMulti, PFileStm;

{$R *.dfm}

procedure TMultiUsrDbForm.BtnGetDbClick(Sender: TObject);
begin
  FreeAndNil(FDbFile);
  If OpenDialog1.Execute then
      FDbFile:=TADUGIndexedDb.Create(OpenDialog1.FileName,fmOpenDb);
  RefreshForm;
end;

procedure TMultiUsrDbForm.BtnNewBusObjClick(Sender: TObject);
Var
  NewBusObject:TADUGMultiBusObj;
begin
  If FDbFile = nil then  BtnGetDbClick(nil);
  If FDbFile = nil then
     Raise Exception.Create('No Database file open');
  NewBusObject:=TADUGMultiBusObj.Create(nil,nil);
  If FDbFile.WriteIndexedObject(NewBusObject)then
               NewBusObject.Edit
    else
       Begin
         FreeAndNil(NewBusObject);
         Raise Exception.Create('Failed to save New Object');
       end;
  RefreshForm;
end;

procedure TMultiUsrDbForm.BtnNewDbCreateClick(Sender: TObject);
begin
  FreeAndNil(FDbFile);
  If SaveDialog1.Execute then
     Try
      FDbFile:=TADUGIndexedDb.Create(OpenDialog1.FileName,fmOpenDb)
     Except
      EraseDb(OpenDialog1.FileName,True);
      FDbFile:=TADUGIndexedDb.Create(OpenDialog1.FileName,fmOpenWriteNew)
     end;
  RefreshForm;
end;

procedure TMultiUsrDbForm.RefreshForm;
begin
  ListBox1.Items.Clear;
  If FDbFile=nil then exit;
  Try
    ListBox1.Items.AddStrings(FDbFile.SecondaryIndexStringList(Idx0,true));
  Except //Suppress Errors
  End;
end;

procedure TMultiUsrDbForm.TimerRefreshFormTimer(Sender: TObject);
begin
   RefreshForm;
end;

procedure TMultiUsrDbForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  FDbFile.Free;
end;

procedure TMultiUsrDbForm.ListBox1DblClick(Sender: TObject);
Var
  LclIndex:Integer;
  LclObj:TADUGMultiBusObj;
begin
  Try
  Visible:=false;
  LclIndex:= ListBox1.ItemIndex;
  If LclIndex<0 then exit;
  LclIndex:=LongInt(ListBox1.Items.Objects[LclIndex]);
  If LclIndex>0 then
        LclObj:=FDbFile.ReadFileObjectByIndex(LclIndex)
     Else LclObj:=nil;
  if LclObj<>nil then
             LclObj.Edit;
  RefreshForm; // Redraw the Edit
  Finally
    Visible:=True;
  end;
end;

end.
